with Ada.Text_IO;

package body OS is

   type ID_T is array (Thread_Id) of Boolean;
   type Proc_T is array (Thread_Id) of Thread;

   --  ID (i) evaluates to False if "i" is a free identifier
   ID : ID_T := (others => False);

   --  Proc (i) contains the access value to the corresponding
   --+ thread procedure
   Proc : Proc_T := (others => null);

   function Thread_Create (Code : Thread) return Thread_Id is
      Index : Thread_Id := Thread_Id'First;
      Found : Boolean := True;
   begin
      while ID (Index) /= False loop
         if Index < Thread_Id'Last then
            Index := Index + 1;
         else
            Found := False;
            exit;
         end if;
      end loop;
      if Found then
         ID (Index) := True;
         Proc (Index) := Code;
         return Index;
      else
         --  fatal error  (not very wise, really)
         raise Program_Error;
      end if;
   end Thread_Create;

   procedure Thread_Start (Id : Thread_Id) is
      use Ada.Text_IO;
   begin
      --  we don't really start a thread here
      --+ to do so we would need real bindings
      --+ to the underlying operating system

      --  Proc (Id).all;
      null;
      --+-----------
      Put_Line ("Thread "
                & Thread_Id'Image (Id)
                & " started ...");
   end Thread_Start;

end OS;
